//Font = Ms Sans serif size 9, non bold, non italic.
//Font = Tahoma size 12, non bold, non italic.
//Font = Tahoma size 16, non bold, non italic.

var g_data_stage = 0;
var g_data_change = 0;

var green = CreateColor(0, 255, 0);
var g_volume_selected = false;
var g_volume_bar_offset = 0;
var g_position_selected = false;
var g_position_bar_offset = 0;

EvaluateScript("cpl2.js");

var i_wmp_skin = LoadImage("wmp-skin.png");
var i_wmp_horizontal_seperator = LoadImage("wmp-horizontal-seperator.png");
var i_wmp_selected_song = LoadImage("wmp-selected-song.png");
var f_selected = LoadFont("selected_font.rfn");
var f_normal = LoadFont("normal_font.rfn");
var f_artist = LoadFont("artist_font.rfn");
var f_title = LoadFont("title_font.rfn");

var i_wmp_pause_button_button_down = LoadImage("wmp-pause-button-button-down.png");
var i_wmp_pause_button_scroll_over = LoadImage("wmp-pause-button-scroll-over.png");
var i_wmp_play_button_normal = LoadImage("wmp-play-button-normal.png");
var i_wmp_play_button_button_down = LoadImage("wmp-play-button-button-down.png");
var i_wmp_play_button_scroll_over = LoadImage("wmp-play-button-scroll-over.png");
var i_wmp_stop_button_button_down = LoadImage("wmp-stop-button-button-down.png");
var i_wmp_stop_button_scroll_over = LoadImage("wmp-stop-button-scroll-over.png");
var i_wmp_logo_scroll_over = LoadImage("wmp-logo-scroll-over.png");

var i_wmp_previous_button_scroll_over = LoadImage("wmp-previous-button-scroll-over.png");
var i_wmp_previous_button_button_down = LoadImage("wmp-previous-button-button-down.png");
var i_wmp_next_button_scroll_over = LoadImage("wmp-next-button-scroll-over.png");
var i_wmp_next_button_button_down = LoadImage("wmp-next-button-button-down.png");

var i_wmp_mute_button_scroll_over = LoadImage("wmp-mute-button-scroll-over.png");
var i_wmp_mute_button_muted = LoadImage("wmp-mute-button-muted.png");
var i_wmp_volume_bar = LoadImage("wmp-volume-bar.png");
var i_wmp_volume_bar_scroll_over = LoadImage("wmp-volume-bar-scroll-over.png");
var i_wmp_volume_bar_button_down = LoadImage("wmp-volume-bar-button-down.png");

var i_wmp_compact_button_scroll_over = LoadImage("wmp-compact-button-scroll-over.png");
var i_wmp_compact_button_button_down = LoadImage("wmp-compact-button-button-down.png");

var i_wmp_position_bar = LoadImage("wmp-position-bar.png");
var i_wmp_position_bar_scroll_over = LoadImage("wmp-position-bar-scroll-over.png");
var i_wmp_position_bar_button_down = LoadImage("wmp-position-bar-button-down.png");

var i_wmp_shuffle_button_scroll_over = LoadImage("wmp-shuffle-button-scroll-over.png");
var i_wmp_shuffle_button_button_down = LoadImage("wmp-shuffle-button-button-down.png");

var i_mouse = LoadImage("mouse.png");
var m_down = undefined;

var g_wmp_horizontal_seperator = 427;
var g_wmp_top_spacing = 42;

CreatePlaylist("sounds", true);
StartPlaylist();

var selected_song = cpl_current_song;

function game(){
	g_data_change = 5000;
	while(IsKeyPressed(KEY_ESCAPE) == false){
		UpdatePlaylist();
		if(m_down != undefined){
			if(GetMouseUp(m_down.x, m_down.y, m_down.width, m_down.height, m_down.callback, m_down.button) == true){
				m_down = undefined;
			}
		}
		
		var m_x = GetMouseX();
		var m_y = GetMouseY();
		
		i_wmp_skin.blit(0, 0);
		i_wmp_horizontal_seperator.blit(g_wmp_horizontal_seperator, g_wmp_top_spacing);
		
		f_artist.drawTextBox(120, 42, g_wmp_horizontal_seperator - 125, 20, 0, cpl_song_info[cpl_current_song].artist);
		f_title.drawTextBox(120, 62, g_wmp_horizontal_seperator - 125, 25, 0, cpl_song_info[cpl_current_song].title);
		
		for(var g_a = 0; g_a < cpl_playlist.length; g_a++){
			var g_song_length_string = cpl_song_info[g_a].minutes + ":";
			if(cpl_song_info[g_a].seconds < 10){
				g_song_length_string += "0";
			}
			g_song_length_string += cpl_song_info[g_a].seconds;
			if(g_a == cpl_current_song){
				f_selected.drawTextBox(g_wmp_horizontal_seperator + 7, g_wmp_top_spacing + 2 + (14 * g_a), 155, 13, 0, cpl_song_info[g_a].title);
				f_selected.drawTextBox(617 - f_selected.getStringWidth(g_song_length_string), g_wmp_top_spacing + 2 + (14 * g_a), 155, 13, 0, g_song_length_string);
			}
			else{
				f_normal.drawTextBox(g_wmp_horizontal_seperator + 7, g_wmp_top_spacing + 2 + (14 * g_a), 155, 13, 0, cpl_song_info[g_a].title);
				f_normal.drawTextBox(617 - f_normal.getStringWidth(g_song_length_string), g_wmp_top_spacing + 2 + (14 * g_a), 155, 13, 0, g_song_length_string);
			}
			if(m_x > g_wmp_horizontal_seperator + 5 && m_y > g_wmp_top_spacing + 2 + (14 * g_a) && m_x < 622 && m_y < g_wmp_top_spacing + 16 + (14 * g_a) && IsMouseButtonPressed(MOUSE_LEFT) == true && g_volume_selected == false && g_position_selected == false){
				selected_song = g_a;
				m_down = new SetMouseDown(g_wmp_horizontal_seperator + 5, g_wmp_top_spacing + 2 + (14 * selected_song), 617 - g_wmp_horizontal_seperator, 14, function(){SkipToSong(selected_song, true)}, MOUSE_LEFT);
			}
			i_wmp_selected_song.blit(g_wmp_horizontal_seperator + 5, g_wmp_top_spacing + 2 + (14 * selected_song));
		}
		if(cpl_playing == false){
			f_selected.drawTextBox(219, 400, 315, 14, 0, "Ready");
		}
		else if(cpl_paused == true){
			f_selected.drawTextBox(219, 400, 315, 14, 0, "Paused");
		}
		else{
			if(GetTime() >= g_data_change){
				g_data_stage++;
				if(g_data_stage > 3){
					g_data_stage = 0;
				}
				g_data_change = GetTime() + 5000;
			}
			if(g_data_stage == 0){
				f_selected.drawTextBox(219, 400, 315, 14, 0, "Playing: 128 K bits/second");
			}
			else if(g_data_stage == 1){
				f_selected.drawTextBox(219, 400, 315, 14, 0, "Song: " + cpl_song_info[cpl_current_song].title);
			}
			else if(g_data_stage == 2){
				f_selected.drawTextBox(219, 400, 315, 14, 0, "Album: " + cpl_song_info[cpl_current_song].album);
			}
			else{
				f_selected.drawTextBox(219, 400, 315, 14, 0, "Artist: " + cpl_song_info[cpl_current_song].artist);
			}
		}
		var g_song_current_position = GetSongPosition(cpl_current_song);
		var g_song_current_minutes = 0;
		var g_song_current_seconds = 0;
		if(g_song_current_position != false){
			var g_song_current_milliseconds = g_song_current_position / 44.1;
			g_song_current_minutes = Math.floor(g_song_current_milliseconds / 60000);
			g_song_current_seconds = Math.floor((g_song_current_milliseconds - g_song_current_minutes * 60000) / 1000);
		}
		var g_song_current_position_string = "" + g_song_current_minutes + ":";
		if(g_song_current_seconds < 10){
			g_song_current_position_string += "0";
		}
		g_song_current_position_string += g_song_current_seconds;
		f_selected.drawTextBox(577 - f_selected.getStringWidth(g_song_current_position_string), 400, f_selected.getStringWidth(g_song_current_position_string), 14, 0,	g_song_current_position_string);
		if(cpl_shuffle == false){
			if(m_x > 396 && m_y > 3 && m_x < 426 && m_y < 33 && g_volume_selected == false && g_position_selected == false){
				if(IsMouseButtonPressed(MOUSE_LEFT) == true){
					m_down = new SetMouseDown(396, 3, 30, 30, function(){cpl_shuffle = true}, MOUSE_LEFT);
					i_wmp_shuffle_button_button_down.blit(396, 3);
				}
				else{
					i_wmp_shuffle_button_scroll_over.blit(396, 3);
				}
			}
		}
		else{
			if(m_x > 396 && m_y > 3 && m_x < 426 && m_y < 33 && IsMouseButtonPressed(MOUSE_LEFT) == true){
				m_down = new SetMouseDown(396, 3, 30, 30, function(){cpl_shuffle = false}, MOUSE_LEFT);
			}
			i_wmp_shuffle_button_button_down.blit(396, 3);
		}
		if(cpl_playing == true && g_volume_selected == false && g_position_selected == false){
			if(cpl_paused == false){
				if(m_x > 116 && m_y > 403 && m_x < 176 && m_y < 463){
					if(IsMouseButtonPressed(MOUSE_LEFT) == true){
						m_down = new SetMouseDown(116, 403, 60, 60, function(){PauseSong()}, MOUSE_LEFT);
						i_wmp_pause_button_button_down.blit(116, 403);
					}
					else{
						i_wmp_pause_button_scroll_over.blit(116, 403);
					}
				}
			}
			else{
				if(m_x > 116 && m_y > 403 && m_x < 176 && m_y < 463){
					if(IsMouseButtonPressed(MOUSE_LEFT) == true){
						m_down = new SetMouseDown(116, 403, 60, 60, function(){UnPauseSong()}, MOUSE_LEFT);
						i_wmp_play_button_button_down.blit(116, 403);
					}
					else{
						i_wmp_play_button_scroll_over.blit(116, 403);
					}
				}
				else{
					i_wmp_play_button_normal.blit(116, 403);
				}
			}
			if(m_x > 181 && m_y > 423 && m_x < 216 && m_y < 468){
				if(IsMouseButtonPressed(MOUSE_LEFT) == true){
					m_down = new SetMouseDown(181, 423, 35, 45, function(){StopSong()}, MOUSE_LEFT);
					i_wmp_stop_button_button_down.blit(181, 423);
				}
				else{
					i_wmp_stop_button_scroll_over.blit(181, 423);
				}
			}
		}
		else if(g_volume_selected == false && g_position_selected == false){
			if(m_x > 116 && m_y > 403 && m_x < 176 && m_y < 463){
				if(IsMouseButtonPressed(MOUSE_LEFT) == true){
					m_down = SetMouseDown(116, 403, 60, 60, PlaySong(cpl_current_song), MOUSE_LEFT);
					i_wmp_play_button_button_down.blit(116, 403);
				}
				else{
					i_wmp_play_button_scroll_over.blit(116, 403);
				}
			}
			else{
				i_wmp_play_button_normal.blit(116, 403);
			}
		}
		if(m_x > 16 && m_y > 413 && m_x < 81 && m_y < 458 && g_volume_selected == false && g_position_selected == false){
			i_wmp_logo_scroll_over.blit(16, 413);
		}
		if(cpl_muted == true){
			i_wmp_mute_button_muted.blit(246, 443);
		}
		if(m_x > 246 && m_y > 443 && m_x < 266 && m_y < 463 && g_volume_selected == false && g_position_selected == false){
			if(IsMouseButtonPressed(MOUSE_LEFT) == true){
				if(cpl_muted == false){
					m_down = new SetMouseDown(246, 443, 20, 20, function(){MutePlaylist()}, MOUSE_LEFT);
				}
				else{
					m_down = new SetMouseDown(246, 443, 20, 20, function(){UnMutePlaylist()}, MOUSE_LEFT);
				}
			}
			if(cpl_muted == false){
				i_wmp_mute_button_scroll_over.blit(246, 443);
			}
		}
		if(m_x > 596 && m_y > 428 && m_x < 621 && m_y < 458 && g_volume_selected == false && g_position_selected == false){
			if(IsMouseButtonPressed(MOUSE_LEFT) == true){
				i_wmp_compact_button_button_down.blit(596, 428);
			}
			else{
				i_wmp_compact_button_scroll_over.blit(596, 428);
			}
		}
		if(m_x > 361 && m_y > 443 && m_x < 386 && m_y < 463 && g_volume_selected == false && g_position_selected == false){
			if(IsMouseButtonPressed(MOUSE_LEFT) == true){
				m_down = new SetMouseDown(361, 443, 25, 20, function(){PreviousSong()}, MOUSE_LEFT);
				i_wmp_previous_button_button_down.blit(361, 443);
			}
			else{
				i_wmp_previous_button_scroll_over.blit(361, 443);
			}
		}
		if(m_x > 441 && m_y > 443 && m_x < 476 && m_y < 463 && g_volume_selected == false && g_position_selected == false){
			if(IsMouseButtonPressed(MOUSE_LEFT) == true){
				m_down = new SetMouseDown(441, 443, 25, 20, function(){NextSong()}, MOUSE_LEFT);
				i_wmp_next_button_button_down.blit(441, 443);
			}
			else{
				i_wmp_next_button_scroll_over.blit(441, 443);
			}
		}
		if(g_position_selected == false){
			if(m_x > 280 && m_y > 442 && m_x < 334 && m_y < 462 && IsMouseButtonPressed(MOUSE_LEFT) == true || g_volume_selected == true){
				if(g_volume_selected == false){
					if(m_x > 280 + (GetSongVolume(cpl_current_song) / 255 * 45) && m_y > 442 && m_x < 290 + (GetSongVolume(cpl_current_song) / 255 * 44) && m_y < 462){
						g_volume_bar_offset = 280 + (GetSongVolume(cpl_current_song) / 255 * 45) - m_x;
					}
					else if(m_x < 285){
						g_volume_bar_offset = m_x - 285;
					}
					else{
						g_volume_bar_offset = -5;
					}
				}
				g_volume_selected = true;
				i_wmp_volume_bar_button_down.blit(280 + (GetSongVolume(cpl_current_song) / 255 * 45), 442);
			}
			else if(m_x > 280 + (GetSongVolume(cpl_current_song) / 255 * 45) && m_y > 442 && m_x < 290 + (GetSongVolume(cpl_current_song) / 255 * 44) && m_y < 462){
				i_wmp_volume_bar_scroll_over.blit(280 + (GetSongVolume(cpl_current_song) / 255 * 45), 442);
			}
			else{
				i_wmp_volume_bar.blit(280 + (GetSongVolume(cpl_current_song) / 255 * 45), 442);
			}
			if(g_volume_selected == true){
				var temp_volume = (m_x - 280 + g_volume_bar_offset) * (255 / 45);
				if(temp_volume > 255){
					temp_volume = 255;
				}
				if(temp_volume < 0){
					temp_volume = 0;
				}
				SetSongVolume(temp_volume);
			}
		}
		else{
			i_wmp_volume_bar.blit(280 + (GetSongVolume(cpl_current_song) / 255 * 45), 442);
		}
		if(IsMouseButtonPressed(MOUSE_LEFT) == false){
			g_volume_selected = false;
			g_position_selected = false;
		}
		if(g_volume_selected == false){
			if(m_x > 243 && m_y > 423 && m_x < 547 && m_y < 438 && IsMouseButtonPressed(MOUSE_LEFT) == true || g_position_selected == true){
				if(g_position_selected == false){
					if(m_x > 243 + (GetSongPosition(cpl_current_song) / GetSongLength(cpl_current_song) * 304) && m_y > 423 && m_x < 258 + (GetSongPosition(cpl_current_song) / GetSongLength(cpl_current_song) * 304) && m_y < 438){
						g_position_bar_offset = 243 + (GetSongPosition(cpl_current_song) / GetSongLength(cpl_current_song) * 304) - m_x;
					}
					else if(m_x < 248){
						g_position_bar_offset = m_x - 248;
					}
					else{
						g_position_bar_offset = -5;
					}
				}
				g_position_selected = true;
				i_wmp_position_bar_button_down.blit(243 + (GetSongPosition(cpl_current_song) / GetSongLength(cpl_current_song) * 304), 423);
			}
			else if(m_x > 243 + (GetSongPosition(cpl_current_song) / GetSongLength(cpl_current_song) * 304) && m_y > 423 && m_x < 258 + (GetSongPosition(cpl_current_song) / GetSongLength(cpl_current_song) * 304) && m_y < 438){
				i_wmp_position_bar_scroll_over.blit(243 + (GetSongPosition(cpl_current_song) / GetSongLength(cpl_current_song) * 304), 423);
			}
			else{
				i_wmp_position_bar.blit(243 + (GetSongPosition(cpl_current_song) / GetSongLength(cpl_current_song) * 304), 423);
			}
			if(g_position_selected == true){
				var temp_position = (m_x - 243 + g_position_bar_offset) * (GetSongLength(cpl_current_song) / 304);
				if(temp_position > GetSongLength(cpl_current_song)){
					temp_position = GetSongLength(cpl_current_song);
				}
				if(temp_position < 0){
					temp_position = 0;
				}
				SetSongPosition(cpl_current_song, temp_position);
			}
		}
		else{
			i_wmp_position_bar.blit(243 + (GetSongPosition(cpl_current_song) / GetSongLength(cpl_current_song) * 304), 423);
		}
		
		i_mouse.blit(m_x, m_y);
		FlipScreen();
	}
}

function SetMouseDown(x, y, width, height, callback, button){
	this.x = x;
	this.y = y;
	this.width = width;
	this.height = height;
	this.callback = callback;
	this.button = button;
}

function GetMouseUp(x, y, width, height, callback, button){
	if(IsMouseButtonPressed(button) == false){
		var m_x = GetMouseX();
		var m_y = GetMouseY();
		if(m_x > x && m_y > y && m_x < x + width && m_y < y + width){
			callback();
		}
		return true;
	}
	return false;
}